/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
    EA_application:  base class for applying a specific EA to a
                     specific landscape.
*/

import java.util.*;

abstract class EA_application
  {

  EA  ea;
  Landscape landscape;
  int simulation_limit;
  int rand_seed;

  abstract void run();


/*
   EA_application constructor:
*/

EA_application(Properties props)
  {
  String seed;
  String limit;
  String report_options;
  StringTokenizer st;
  String token;

  limit = props.getProperty("SimLimit");
  if (limit == null) {
      Util.ec_warn("no SimLimit specified; default used.");
      simulation_limit = 100;
      }
  else simulation_limit = Integer.parseInt(limit);
  System.out.println("  Simulation time limit (# births): " + simulation_limit);

  seed = props.getProperty("RandSeed");
  if (seed == null) {
      Util.ec_warn("no RandSeed specified; default used.");
      rand_seed = 12345;
      }
  else rand_seed = Integer.parseInt(seed);
  System.out.println("  Random number seed (positive integer): " + rand_seed);
  }

}











