/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
   EC1: A simple introductory example of a simple evolutionary algorithm EV
        being applied to real-valued parameter optimization problems.
*/

import java.io.*;
import java.util.*;

class EC1
{

public static void main (String args[])   // The top level control loop
  {
  String fileName;
  Properties props = new Properties();    
  StringTokenizer  st;
  String lscape_props;
  String lscape_type;
  EA_application  ea_app = null;


  System.out.println("EC1:");

  if (args.length > 0)  fileName = args[0]; 
  else  fileName = "ec1.cfg";

  try
    {
    File  confFile = new File(".",fileName);  // File(dir,file)
    props.load(new FileInputStream(confFile));
    }
  catch (Exception e) {
        Util.ec_error(e.toString());
	}

  lscape_props = props.getProperty("Landscape");
  if (lscape_props == null)
      Util.ec_error("missing Landscape property");
 
  st = new StringTokenizer(lscape_props," ");
  lscape_type = st.nextToken();
  if (!lscape_type.equals("RVP"))
       Util.ec_error("unknown landscape type: " + lscape_type);

  ea_app = new RvpEA_application(st, props);
  ea_app.run();                // Run application
  }
}
