/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
   RvpEA_application:  apply a specific EA to specific real-valued
                       parameter optimization landscape.
*/

import java.util.*;


class RvpEA_application  extends EA_application
    {

/*
   RvpEA_application constructor:
*/

RvpEA_application(StringTokenizer lscape_props, Properties props)
    {
    super(props);
   
    String lscape_name;

    if (! lscape_props.hasMoreTokens())
	Util.ec_error("missing landscape name.");

    lscape_name = lscape_props.nextToken();
    if (! lscape_name.equals("Parabola"))
	Util.ec_error("unknown landscape: " + lscape_name);


    landscape = new Parabola(lscape_props);
    landscape.print_info();

    ea = new RvpEV(props, (RvpLscape) landscape, rand_seed);
    }


/*
  run: runs the given EA on the given landscape
*/

void run()
  {
  ea.run(simulation_limit);
  }

}
