/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
    RvpEV:  one class of simple evolutionary algorithms for Rvp Landscapes
*/

import java.util.*;


class RvpEV   extends RvpEA
    {



/*
    RvpEV constructor
*/

RvpEV(Properties props, RvpLscape rls, int rand_seed)
    {
    super(props, rls, rand_seed);
    }



/*
  run:  run the EA
*/

void run(int birth_limit)
    {
    Individual  parent;
    Individual  child;


    while (birth_cnt < birth_limit)
	{
	parent = select_parent();
	child = reproduce(parent);
	survival(child);

	if ((birth_cnt % pop.pop_size) == 0)  dump();
	}

    print_best();
    }


/*
  cleanup:  
*/

void cleanup() {}



/*
  select_parent: parent selection procedure
*/

Individual  select_parent()
  {
  return (pop.select_uniform());
  }



/*
  Reproduce:  given a parent, produces a child similar to the
                  parent via cloning and mutation.
*/

Individual reproduce(Individual  parent)
  {
  Individual  child = parent.copy(++birth_cnt);

  child.mutate(rand, mutation_type, mutation_step_size);

  pop.eval(child);
  return child;
  }



/*
  Survival:  conditionally inserts child into the population
                 by replacing an existing member.
*/

void survival(Individual  child)
  {
  pop.uniform_survival(child);
  }


}

