/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
  RvpLscape.java:  an abstract class of real-valued parameter
                 fitness landscapes.
*/


abstract class RvpLscape  extends Landscape

    {

    int param_cnt;               // # parameters

    float init_param_lbd[];      // param. initialization lower bounds
    float init_param_ubd[];      // param. initialization upper bounds

    float hard_param_lbd[];      // hard parameter lower bounds
    float hard_param_ubd[];      // hard parameter upper bounds

    boolean  inverted = false;   // true ==> return -f as fitness

    abstract float   eval(float param[]);       // computes parameters' fitness
    abstract boolean legal(float param[]);      // check legality of params

    }

