/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
   BinaryIndividual:   population members with binary-valued genes
*/

class BinaryIndividual  extends Individual
    {


/*
   BinaryIndividual Constructor: random genome
*/

BinaryIndividual(int birthday, EC_rand rand)
    {
    super(birthday);

    genome = new BinaryRepresentation(rand);
    }


/*
   Individual Constructor:
*/

BinaryIndividual()
    {
    super();

    genome = new BinaryRepresentation();
    }


void eval()
  {
  fitness = genome.eval();
  return;
  }


void mutate(EA ea)
  {
  genome.mutate(ea);
  }


void crossover(Individual mate, EA ea)
  {
  genome.crossover(mate.genome, ea.rand);

  }

Individual copy(int birthday)
  {
  BinaryIndividual cp = new BinaryIndividual();

  cp.birthdate = birthday;
  cp.fitness = this.fitness;
  cp.parent_fitness = this.parent_fitness;
  cp.genome = (Genome) this.genome.copy();
  return ((Individual) cp);
  }


Individual copy()
  {
  BinaryIndividual cp = new BinaryIndividual();

  cp.birthdate = this.birthdate;
  cp.fitness = this.fitness;
  cp.parent_fitness = this.parent_fitness;
  cp.genome = this.genome.copy();
  return ((Individual) cp);
  }


}

