/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
   BinaryRepresentation:  binary-valued vector representations
*/

import java.util.*;


class BinaryRepresentation  extends BinaryOperators
    {


/*
   BinaryRepresentation constructor:
*/

BinaryRepresentation(EC_rand rand)
  {
  super(rand);
  }


BinaryRepresentation()
  {
  super();
  }



static void BinaryRepresentationInit(Properties props, RvpLscape rls, EA ea)
    {
    BinaryGenomeInit(rls);

    ea.global_max = new BinaryIndividual();
    ea.global_min = new BinaryIndividual();
    ea.global_max.fitness = Float.NEGATIVE_INFINITY;
    ea.global_min.fitness = Float.POSITIVE_INFINITY;
    ea.parent_pop = new BinaryPopulation(ea, ea.parent_pop_size, ea.rand);

    BinaryOperators.BinaryOperatorsInit(props, ea);
    }




/*
   copy:
*/

Genome copy()
  {
  BinaryRepresentation  dupl = new BinaryRepresentation();

  dupl.gene_cnt = gene_cnt;
  dupl.gene = new int[gene_cnt];

  System.arraycopy(gene, 0, dupl.gene, 0, gene_cnt);

  return ((Genome) dupl);
  }


}
