/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
   RealGenome:   a simple real-valued parameter genome representation 
*/


import java.text.DecimalFormat;


abstract class RealGenome  extends Genome 
    {

    static float gene_lbd[];
    static float gene_ubd[];
    float        gene[];


/*
   Genome constructor: uses a uniform random number generator to assign
                initial values to each gene from the range specified 
		by the the given lower and upper bounds.
*/

RealGenome(EC_rand rand)
  {
  int  i;

  gene = new float[gene_cnt];

  for (i=0; i<gene_cnt; i++)
    gene[i] = gene_lbd[i] + (gene_ubd[i] - gene_lbd[i]) * rand.frand();
  }



/*
   Genome Constructor:
*/

RealGenome()
  {
  int  i;

  gene = new float[gene_cnt];

  }




/*
   RealGenomeInit: initializes the genome/phenome mapping for entire class
*/

static void RealGenomeInit(RvpLscape lscape) 
  {
  int i;

  rls = lscape;

  gene_cnt = rls.param_cnt;
  gene_lbd = new float[gene_cnt];
  gene_ubd = new float[gene_cnt];

  for (i=0; i<gene_cnt; i++) {
      gene_lbd[i] = rls.init_param_lbd[i];
      gene_ubd[i] = rls.init_param_ubd[i];
      }

  System.out.println("  Using a genome with " + gene_cnt +
		     " real-valued gene(s).");

  }



/*
   eval:
*/

float eval()
  {
  return (rls.eval(gene));
  }




DecimalFormat f12_5 = new DecimalFormat("#####0.00000");


/*
   print_genome:  prints the gene values as real numbers
*/

void print()
  {
  int  i;

  for (i=0; i<gene_cnt; i++)
        System.out.print(Util.pad_left(f12_5.format(gene[i]), 13));
  }


}



