/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
  RealIndividual:   population members with real-valued genes
*/

class RealIndividual  extends Individual
    {


/*
   Individual Constructor: random genome
*/

RealIndividual(int birthday, EC_rand rand)
    {
    super(birthday);

    genome = new RealRepresentation(rand);
    }


/*
   Individual Constructor:
*/

RealIndividual()
    {
    super();

    genome = new RealRepresentation();
    }


void eval()
  {
  fitness = genome.eval();
  return;
  }


void mutate(EA ea)
  {
  genome.mutate(ea);
  }



void crossover(Individual mate, EA ea)
  {
  genome.crossover(mate.genome, ea.rand);
  }


Individual copy(int birthday)
  {
  RealIndividual cp = new RealIndividual();

  cp.birthdate = birthday;
  cp.fitness = this.fitness;
  cp.parent_fitness = this.parent_fitness;
  cp.genome = this.genome.copy();
  return ((Individual) cp);
  }


Individual copy()
  {
  RealIndividual cp = new RealIndividual();

  cp.birthdate = this.birthdate;
  cp.fitness = this.fitness;
  cp.parent_fitness = this.parent_fitness;
  cp.genome = this.genome.copy();
  return ((Individual) cp);
  }


}

