/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
   RealPopulation: Populations of Real-valued Individuals
*/


import java.util.*;


class RealPopulation extends Population
  {

/*
   RealPopulation constructor for populations with randomly generated individuals
*/

RealPopulation(EA ea, int pop_size, EC_rand rand)
  {
  super(ea, pop_size);

  int  i;

  for (i=0; i<pop_size; i++)       /* create initial population */
    {
    indiv[i] = new RealIndividual(++ea.birth_cnt, rand);
    evaluate(indiv[i]);
    }

  local_max = new RealIndividual();
  local_min = new RealIndividual();
}


/*
   Population constructor for populations with no initial Individuals
*/

RealPopulation(EA ea, int pop_size)
  {
  super(ea, pop_size);

  local_max = new RealIndividual();
  local_min = new RealIndividual();
  }



}











