/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
  RealRepresentation:  real-valued vector representations
*/

import java.util.*;


class RealRepresentation  extends RealOperators
    {


/*
   RealRepresentation constructor:
*/

RealRepresentation(EC_rand rand)
    {
    super(rand);
    }


RealRepresentation()
    {
    super();
    }


/*
  Class-level initialization
*/

static void RealRepresentationInit(Properties props, RvpLscape rls, EA ea)
    {
    RealGenomeInit(rls);

    ea.global_max = new RealIndividual();
    ea.global_min = new RealIndividual();
    ea.global_max.fitness = Float.NEGATIVE_INFINITY;
    ea.global_min.fitness = Float.POSITIVE_INFINITY;
    ea.parent_pop = new RealPopulation(ea, ea.parent_pop_size, ea.rand);

    RealOperatorsInit(props, ea);
    }


Genome copy()
  {
  RealRepresentation  dupl = new RealRepresentation();

  dupl.gene_cnt = gene_cnt;
  dupl.gene = new float[gene_cnt];

  System.arraycopy(gene, 0, dupl.gene, 0, gene_cnt);

  return ((Genome) dupl);
  }


}
