/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
    EP_EA:  a simple Evolutionary Programming EA
*/

import java.util.*;


class EP_EA   extends EA
    {


/*
    EP_EA constructor:
*/

EP_EA(Properties props, Landscape lscape, int rand_seed)
    {
    super(rand_seed);

    ea_type = "EP";
    parent_pop_size = 10;   // defaults
    brood_size = 1;

    representation_name = "real";
    representation_type = real_rep;

    parent_selection_name = "uniform_deterministic";
    parent_selection_type = uniform_deterministic;
    mate_selection_type = uniform_stochastic;

    generation_name = "overlapping";
    generation_type = overlapping;

    survival_selection_name = "truncation";
    survival_selection_type = truncation;


    EA_init(props, lscape);         // finish general EA initialization;
    }



/*
  adapt_operators:  dynamically adjust operator parameters
*/

void adapt_operators()
    {
    }


/*
  Adaptation_stats:
*/

void adaptation_stats()
  {
  }

}

