/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
    EV_EA:  the simplest evolutionary algorithm
*/

import java.util.*;


class EV_EA   extends EA
    {

/*
    EV_EA constructor
*/

EV_EA(Properties props, Landscape lscape, int rand_seed)
    {
    super(rand_seed);

    ea_type = "EV";
    parent_pop_size = 10;   // defaults;
    offspring_pop_size = 1;
    brood_size = 0;

    representation_name = "real";
    representation_type = real_rep;

    parent_selection_name = "uniform_stochastic";
    parent_selection_type = uniform_stochastic;
    mate_selection_type = uniform_stochastic;

    generation_name = "overlapping";
    generation_type = overlapping;

    survival_selection_name = "binary_tournament";
    survival_selection_type = binary_tournament;

    EA_init(props, lscape);         // finish general EA initialization;
    }


/*
  adapt_operators:  dynamically adjust operator parameters
*/

void adapt_operators()
    {
    }


/*
  Adaptation_stats:
*/

void adaptation_stats()
  {
  }

}

