/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
   EC4: A unified example of evolutionary algorithms
        being applied to a variety of parameter optimization problems
	including real-valued and integer-valued parameters.
*/

import java.io.*;
import java.util.*;

class EC4
{

public static void main (String args[])   // The top level control loop
  {
  String fileName;
  Properties props = new Properties();    
  StringTokenizer  st;
  String lscape_props;
  String lscape_type;
  EA_application  ea_app = null;


  System.out.println("EC4:");

  if (args.length > 0)  fileName = args[0]; 
  else  fileName = "ec4.cfg";

  try
    {
    File  confFile = new File(".",fileName);  // File(dir,file)
    props.load(new FileInputStream(confFile));
    }
    catch (Exception e)	{
        Util.ec_error(e.toString());
	}

  lscape_props = props.getProperty("Landscape");
  if (lscape_props == null)
      Util.ec_error("missing Landscape property");
 
  st = new StringTokenizer(lscape_props," ");
  lscape_type = st.nextToken();
  if (lscape_type.equals("RVP")) ea_app = new RvpEA_application(st, props);
  else if (lscape_type.equals("IVP")) ea_app = new IvpEA_application(st, props);
  else  Util.ec_error("unknown landscape type: " + lscape_type);

  ea_app.run();                // Run application
  }
}
