/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
  Individual:   base class for population members
*/

abstract class Individual  {

    int    birthdate;
    float  fitness;
    float  parent_fitness;
    Genome genome;


/*
   Individual Constructor: random genome
*/

Individual(int birthday)
    {
    birthdate = birthday;
    parent_fitness = Float.NEGATIVE_INFINITY;
    }


/*
   Individual Constructor:
*/

Individual()
    {
    }

/*
   run_eset:  reset individual for new run
*/

void run_reset(int birthday, EC_rand rand)
    {
    birthdate = birthday;
    parent_fitness = Float.NEGATIVE_INFINITY;
    genome.run_reset(rand);
    }



void eval()
  {
  fitness = genome.eval();
  return;
  }



void mutate(EA ea)
  {
  genome.mutate(ea);
  }


void crossover(Individual mate, EA ea)
  {
  genome.crossover(mate.genome, ea.rand);

  }

Individual clone(int birthday)
  {
  Individual cp = this.copy();

  cp.birthdate = birthday;
  return ((Individual) cp);
  }


abstract Individual copy();

}

