/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
   IvpEA_application:  apply a specific EA to specific integer-valued
                       parameter optimization landscape.
*/

import java.util.*;


class IvpEA_application  extends EA_application
    {

/*
   IvpEA_application constructor:
*/

IvpEA_application(StringTokenizer lscape_props, Properties props)
    {
    super(props);
   
    String lscape_name;

    if (! lscape_props.hasMoreTokens()) Util.ec_error("missing landscape name.");

    lscape_name = lscape_props.nextToken();
    if (lscape_name.equals("Nmax"))         landscape = new Nmax(lscape_props);  
    else if (lscape_name.equals("Nsum"))  landscape = new Nsum(lscape_props);  
    else if (lscape_name.equals("Nmatch"))  landscape = new Nmatch(lscape_props);  
    else if (lscape_name.equals("Robbins"))  landscape = new Robbins(lscape_props);  
    else if (lscape_name.equals("Graph2r"))  landscape = new Graph2r(lscape_props);
    else if (lscape_name.equals("Graph2c"))  landscape = new Graph2c(lscape_props);
    else  Util.ec_error("unknown landscape: " + lscape_name);

    landscape.print_info();

    EA_applicationInit(props);   // finish class initialization
    }



/*
  run: runs the given EA on the given landscape
*/

void run()
  {
  int i;

  for (i=1; i<= run_count;i++)  ea.run(simulation_limit);
  
  if (run_count==1) ea.print_best();
  }

}
