/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
  IvpLscape.java:  an abstract class of integer-valued parameter
                 fitness landscapes.
*/


abstract class IvpLscape  extends ParamLscape

    {

    int init_param_lbd[];      // param. initialization lower bounds
    int init_param_ubd[];      // param. initialization upper bounds
    int init_param_res[];      // resolution for binary reps

    int hard_param_lbd[];      // hard parameter lower bounds
    int hard_param_ubd[];      // hard parameter upper bounds
    
    int genotype_cardinality = 0;	// for Robbins equilibrium stats

    boolean  inverted = false;   // true ==> return -f as fitness

    abstract float   eval(int param[]);       // computes parameters' fitness
    abstract boolean legal(int param[]);      // check legality of params

    }

