/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
   RealPopulation: Populations of Real-valued Individuals
*/


import java.util.*;


class RealPopulation extends Population
  {

/*
   RealPopulation constructor for populations with randomly generated individuals
*/

RealPopulation(EA ea, int pop_size, EC_rand rand)
  {
  super(ea, pop_size);

  int  i;

  for (i=0; i<pop_size; i++)       /* create initial population */
    {
    indiv[i] = new RealIndividual();
    }

}


/*
   Population constructor for populations with no initial Individuals
*/

RealPopulation(EA ea, int pop_size)
  {
  super(ea, pop_size);
  }


/*
   Dispersion
*/

float Dispersion()
  {
  int  i,j;
  float  diff;
  float  ave_dist = 0;
  RealIndividual  centroid = new RealIndividual();
  
  centroid.genome = new RealGenome();
  for (j=0; j<Genome.gene_cnt; j++)  ((RealGenome) (centroid.genome)).gene[j] = 0;
  
  for (i=0; i<pop_size; i++)
     for (j=0; j<Genome.gene_cnt; j++) {
        ((RealGenome) (centroid.genome)).gene[j] += ((RealGenome) (indiv[i].genome)).gene[j];
        }
        
  for (j=0; j<Genome.gene_cnt; j++)
    ((RealGenome) (centroid.genome)).gene[j] = ((RealGenome) (centroid.genome)).gene[j] / pop_size;
  
  for (i=0; i<pop_size; i++)
        ave_dist += indiv[i].genome.distance(centroid.genome);
    
        
  return (ave_dist/pop_size);
  
  }



}











