/*       Copyrighted by Kenneth De Jong - 2005          */
/* Licensed under the Academic Free License version 2.1 */

/*
   RvpEA_application:  apply a specific EA to specific real-valued
                       parameter optimization landscape.
*/

import java.util.*;


class RvpEA_application  extends EA_application
    {

/*
   RvpEA_application constructor:
*/

RvpEA_application(StringTokenizer lscape_props, Properties props)
    {
    super(props);
   
    String lscape_name;

    if (! lscape_props.hasMoreTokens())
	Util.ec_error("missing landscape name.");

    lscape_name = lscape_props.nextToken();
    if (lscape_name.equals("Constant")) landscape = new Constant(lscape_props);
    else if (lscape_name.equals("Linear")) landscape = new Linear(lscape_props);
    else if (lscape_name.equals("Parabola")) landscape = new Parabola(lscape_props);
    else if (lscape_name.equals("Rosenbrock")) landscape = new Rosenbrock(lscape_props);
    else Util.ec_error("unknown landscape: " + lscape_name);

    landscape.print_info();

    EA_applicationInit(props);      // finish class initialization
    }


/*
  run: runs the given EA on the given landscape
*/

void run()
  {
  int i;

  for (i=1; i<= run_count;i++)  ea.run(simulation_limit);

  if (run_count==1) ea.print_best();

  }

}
